package de.erethon.papyrus;


import net.minecraft.core.Holder;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.Attributes;

public enum CraftPDamageType {

    AIR(Attributes.ADV_AIR, Attributes.RES_AIR, Attributes.PEN_MAGICAL,  PDamageType.AIR),
    EARTH(Attributes.ADV_EARTH, Attributes.RES_EARTH, Attributes.PEN_MAGICAL, PDamageType.EARTH),
    FIRE(Attributes.ADV_FIRE, Attributes.RES_FIRE, Attributes.PEN_MAGICAL, PDamageType.FIRE),
    MAGIC(Attributes.ADV_MAGIC, Attributes.RES_MAGIC, Attributes.PEN_MAGICAL, PDamageType.MAGIC),
    PHYSICAL(Attributes.ADV_PHYSICAL, Attributes.RES_PHYSICAL, Attributes.PEN_PHYSICAL,PDamageType.PHYSICAL),
    WATER(Attributes.ADV_WATER, Attributes.RES_WATER, Attributes.PEN_MAGICAL, PDamageType.WATER),
    PURE(Attributes.ADV_PURE, Attributes.RES_PURE, Attributes.PEN_PHYSICAL, PDamageType.PURE);

    public final Holder<Attribute> advantage;
    public final Holder<Attribute> res;
    public final Holder<Attribute> pen;
    public final PDamageType apiType;


    CraftPDamageType(Holder<Attribute> advantage, Holder<Attribute> res, Holder<Attribute> pen, PDamageType apiType) {
        this.advantage = advantage;
        this.res = res;
        this.pen = pen;
        this.apiType = apiType;
    }

    public static CraftPDamageType ofAPI(PDamageType apiType) {
        switch (apiType) {
            case AIR -> {
                return CraftPDamageType.AIR;
            }
            case EARTH -> {
                return CraftPDamageType.EARTH;
            }
            case FIRE -> {
                return CraftPDamageType.FIRE;
            }
            case MAGIC -> {
                return CraftPDamageType.MAGIC;
            }
            case PHYSICAL -> {
                return CraftPDamageType.PHYSICAL;
            }
            case WATER -> {
                return CraftPDamageType.WATER;
            }
            case PURE -> {
                return CraftPDamageType.PURE;
            }
        }
        return CraftPDamageType.PURE;
    }
}
