package de.erethon.papyrus;

import net.minecraft.core.BlockPos;
import net.minecraft.core.Holder;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.util.random.WeightedRandomList;
import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.level.StructureManager;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.world.level.biome.MobSpawnSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

import javax.annotation.Nullable;

public class MobSpawnSettingsEvent extends Event {

    private static final HandlerList handlers = new HandlerList();

    public ServerLevel level;
    public StructureManager structureAccessor;
    public ChunkGenerator chunkGenerator;
    public MobCategory spawnGroup;
    public BlockPos pos;
    public Holder<Biome> biomeEntry;
    public WeightedRandomList<MobSpawnSettings.SpawnerData> spawnerData;


    public MobSpawnSettingsEvent(ServerLevel level, StructureManager structureAccessor, ChunkGenerator chunkGenerator, MobCategory spawnGroup, BlockPos pos, @Nullable Holder<Biome> biomeEntry) {
        this.level = level;
        this.structureAccessor = structureAccessor;
        this.chunkGenerator = chunkGenerator;
        this.spawnGroup = spawnGroup;
        this.pos = pos;
        this.biomeEntry = biomeEntry;
    }

    @NotNull
    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }
}
